﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Oscilloscope
{
    static class Constants
    {
        //public const double MEASUREMENT_CYCLE_DEFAULT = 1;
        //public const int LOG_OUTPUT_CYCLE = 5;
        //public const int LOG_OUTPUT_MAX = 1000;

        public const double CALIBRATION_A_DEFAULT = 0.6;
        public const double CALIBRATION_B_DEFAULT = -0.3;

        public const int MEASURE_DATA_BUFF_SIZE = 4000;
        public const int MEASURE_RCV_DATA_HEADER_SIZE = 2;
        public const int MEASURE_RCV_DATA_FOOTER_SIZE = 1;
        public const int MEASURE_DATA_NUM = 2000;
        // 測定データのヘッダーとフッター
        public const byte MEASUREMENT_HEADER1 = 0x53;   // 'S'
        public const byte MEASUREMENT_HEADER2 = 0x4D;   // 'M'
        public const byte MEASUREMENT_FOOTER1 = 0x45;   // 'E'

        public const string INIT_FILE_NAME = "oscilloscope_init_setting.xml";
    }
    //public class MeasureVal
    //{
    //    public double voltage;
    //    public double current;
    //    public double resistance_h;
    //    public double resistance_l;
    //    public double capacitance;
    //    public double frequency;

    //    public MeasureVal()
    //    {
    //        try
    //        {
    //            voltage = 0;
    //            current = 0;
    //            resistance_h = 0;
    //            resistance_l = 0;
    //            capacitance = 0;
    //            frequency = 0;
    //        }
    //        catch
    //        {
    //        }
    //    }

    //    public int Init()
    //    {
    //        int ret = 0;
    //        try
    //        {
    //            voltage = 0;
    //            current = 0;
    //            resistance_h = 0;
    //            resistance_l = 0;
    //            capacitance = 0;
    //            frequency = 0;
    //        }
    //        catch
    //        {
    //        }
    //        return ret;
    //    }
    //    public int Dispose()
    //    {
    //        int ret = 0;
    //        try
    //        {
    //        }
    //        catch
    //        {
    //        }
    //        return ret;
    //    }
    //}
    [Serializable()]
    public class SettingVal
    {
        [System.Xml.Serialization.XmlElement("CALIBRATION_A")]
        public double[] calibration_a;
        [System.Xml.Serialization.XmlElement("CALIBRATION_B")]
        public double[] calibration_b;

        public SettingVal()
        {
        }
        public SettingVal(int p_ch_num)
        {
            try
            {
                calibration_a = new double[p_ch_num];
                calibration_b = new double[p_ch_num];
                for (int fi = 0; fi < p_ch_num; fi++)
                {
                    calibration_a[fi] = Constants.CALIBRATION_A_DEFAULT;
                    calibration_b[fi] = Constants.CALIBRATION_B_DEFAULT;
                }
            }
            catch
            {
            }
        }

        public int Init(int p_ch_num)
        {
            int ret = 0;
            try
            {
                calibration_a = new double[p_ch_num];
                calibration_b = new double[p_ch_num];
                for (int fi = 0; fi < p_ch_num; fi++)
                {
                    calibration_a[fi] = Constants.CALIBRATION_A_DEFAULT;
                    calibration_b[fi] = Constants.CALIBRATION_B_DEFAULT;
                }
            }
            catch
            {
            }
            return ret;
        }
        public int Dispose()
        {
            int ret = 0;
            try
            {
            }
            catch
            {
            }
            return ret;
        }
    }

    [Serializable()]
    public class CorrectionVal
    {
        [System.Xml.Serialization.XmlElement("CALIBRATION_A")]
        public double calibration_a;
        [System.Xml.Serialization.XmlElement("CALIBRATION_B")]
        public double calibration_b;

        public CorrectionVal()
        {
            try
            {
                calibration_a = Constants.CALIBRATION_A_DEFAULT;
                calibration_b = Constants.CALIBRATION_B_DEFAULT;
            }
            catch
            {
            }
        }

        public int Init()
        {
            int ret = 0;
            try
            {
                calibration_a = Constants.CALIBRATION_A_DEFAULT;
                calibration_b = Constants.CALIBRATION_B_DEFAULT;
            }
            catch
            {
            }
            return ret;
        }
        public int Dispose()
        {
            int ret = 0;
            try
            {
            }
            catch
            {
            }
            return ret;
        }
    }
}
