﻿using System;
using System.IO;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Windows.Forms.DataVisualization;
using System.Windows.Forms.DataVisualization.Charting;

namespace Oscilloscope
{
    public partial class Form1 : Form
    {
        int[] baud_rate_select_datas = new int[12] { 1200, 2400, 3600, 9600, 19200, 38400, 57600, 76800, 115200, 230400, 460800, 921600 };
        const int baud_rate_default_select_idx = 8;
        const int SERIAL_RECEIVED_BUFF_SIZE = 0x4000;
        byte[] serial_received_buff = new byte[SERIAL_RECEIVED_BUFF_SIZE];
        int serial_rcv_data_read_idx = 0;
        int serial_rcv_data_write_idx = 0;
        bool serial_rcv_data_full = false;


        // Log file
        bool logfile_out_flag = false;
        StreamWriter[] sw_serial_log = new StreamWriter[GRAPH_CH_NUM] { null, null };
        //const string LOG_FILE_NAME = "\\OSCILLOSCOPE_LOG_";
        string[] LOG_FILE_NAME_CH = new string[GRAPH_CH_NUM] { "\\OSCILLOSCOPE_LOG_CH1_", "\\OSCILLOSCOPE_LOG_CH2_" };
        const string LOG_FILE_EXTEN = ".csv";
        string[] LOG_FILE_HEADER = new string[2] { "no", "Val" };
        //DateTime dt_log_next_output = DateTime.Now;
        int[] log_output_data_counter = new int[GRAPH_CH_NUM];

        public SettingVal mySettingVal = new SettingVal(GRAPH_CH_NUM);
        //public SettingVal mySettingValtmp = new SettingVal();
        //public CorrectionVal myCorrectionVal = new CorrectionVal();
        //public CorrectionVal myCorrectionValtmp = new CorrectionVal();
        public bool setting_val_input_disabled = false;

        // オシロ　グラフ　設定
        const int GRAPH_CH_NUM = 2;
        // 垂直軸設定
        const double GRAPH_VOLTAGE_SET_VAL_MIN = -1.5;
        const double GRAPH_VOLTAGE_SET_VAL_MAX = 1.5;
        const double GRAPH_VOLTAGE_SET_INTERVAL = 0.5;
        const double GRAPH_X_DATA_MIN = 0;
        const double GRAPH_X_DATA_MAX = 4095;
        // 時間軸設定
        const double GRAPH_TIME_SET_VAL_MIN = 0;
        const double GRAPH_TIME_SET_VAL_MAX = 2000;
        const double GRAPH_TIME_SET_INTERVAL = 100;
        const int GRAPH_TIME_DIV_ITEM_NUM = 7;
        const int GRAPH_TIME_DIV_ITEM_DEFAULT = 4;  // デフォルト時間軸 1msec/div
        string[] GRAPH_TIME_DIV_ITEM = new string[GRAPH_TIME_DIV_ITEM_NUM] { "5μsec/div", "10μsec/div", "50μsec/div", "100μsec/div", "1msec/div", "2msec/div", "10msec/div" };
        string[] GRAPH_TIME_TITLE_ITEM = new string[GRAPH_TIME_DIV_ITEM_NUM] { "5μsec/dev", "10μsec/dev", "50μsec/dev", "100μsec/dev", "1msec/dev", "2msec/dev", "10msec/dev" };
        double[] GRAPH_X_MIN_VALUE = new double[GRAPH_TIME_DIV_ITEM_NUM] { 0, 0, 0, 0, 0, 0, 0 };
        double[] GRAPH_X_MAX_VALUE = new double[GRAPH_TIME_DIV_ITEM_NUM] { 50, 100, 500, 1000, 10, 20, 100 };
        double[] GRAPH_X_INTERVAL_VALUE = new double[GRAPH_TIME_DIV_ITEM_NUM] { 5, 10, 50, 100, 1, 2, 10 };
        double[] GRAPH_X_DISP_DATA_NUM = new double[GRAPH_TIME_DIV_ITEM_NUM] { 200, 400, 2000, 1000, 2000, 2000, 2000 };
        int[] graph_x_select_index = new int[GRAPH_CH_NUM] {GRAPH_TIME_DIV_ITEM_DEFAULT, GRAPH_TIME_DIV_ITEM_DEFAULT};
        // トリガーレベルデフォルト値
        const double TRIGGER_LEVEL_MIN_VAL = -1.5;
        const double TRIGGER_LEVEL_MAX_VAL = 1.5;
        const double TRIGGER_LEVEL_DEFAULT_VAL = 0;
        // トリガーエッジ設定
        const int TRIGGER_EDGE_ITEM_NUM = 2;
        const int TRIGGER_EDGE_ITEM_DEFAULT = 0;  // デフォルトトリガーエッジ
        string[] TRIGGER_EDGE_ITEM = new string[TRIGGER_EDGE_ITEM_NUM] { "立ち下がり", "立ち上がり" };

        // 測定データ要求コマンド
        byte[] set_time_val = new byte[GRAPH_CH_NUM];
        byte set_ch_val = 0;
        int[] set_trigger_level = new int[GRAPH_CH_NUM];
        byte[] set_trigger_edge = new byte[GRAPH_CH_NUM];
        //const int MEASURE_DATA_BUFF_SIZE = 4000;
        //const int MEASURE_RCV_DATA_HEADER_SIZE = 2;
        //const int MEASURE_RCV_DATA_FOOTER_SIZE = 1;
        byte[,] Measure_Data_Rcv_Buffer = new byte[GRAPH_CH_NUM, Constants.MEASURE_DATA_BUFF_SIZE + Constants.MEASURE_RCV_DATA_HEADER_SIZE + Constants.MEASURE_RCV_DATA_FOOTER_SIZE];
        //const int MEASURE_DATA_NUM = 2000;
        int[,] Measure_Data_Buff = new int[GRAPH_CH_NUM, Constants.MEASURE_DATA_NUM];
        double[,] Measure_Graph_Data_Buff = new double[GRAPH_CH_NUM, Constants.MEASURE_DATA_NUM];

        ComboBox[] my_cmbbx_time;
        NumericUpDown[] my_num_trigger_level;
        ComboBox[] my_cmbbx_trigger_edge;

        NumericUpDown[] my_num_calibration_a;
        NumericUpDown[] my_num_calibration_b;
        NumericUpDown[] my_num_calibration_kitai;   // 期待値
        TextBox[] my_txtbx_calibration_input;
        TextBox[] my_txtbx_calibration_cal;         // 校正後の計算値

        //public MeasureVal myMeasureVal = new MeasureVal();
        public bool measure_start_flag = false;
        bool graph_update_flag = false;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
#if DEBUG
#else
                this.Size = new System.Drawing.Size(1115, 810);

                groupBox1.Visible = false;
#endif
            //自分自身のバージョン情報を取得する
            System.Diagnostics.FileVersionInfo fver = System.Diagnostics.FileVersionInfo.GetVersionInfo(System.Reflection.Assembly.GetExecutingAssembly().Location);
            this.Text += fver.FileVersion;

            my_cmbbx_time = new ComboBox[GRAPH_CH_NUM] { cmbbx_ch1_time, cmbbx_ch2_time };
            my_num_trigger_level = new NumericUpDown[GRAPH_CH_NUM] { num_ch1_trigger_level, num_ch2_trigger_level };
            my_cmbbx_trigger_edge = new ComboBox[GRAPH_CH_NUM] { cmbbx_ch1_trigger_edge, cmbbx_ch2_trigger_edge };
            my_num_calibration_a = new NumericUpDown[GRAPH_CH_NUM] { num_ch1_a, num_ch2_a };
            my_num_calibration_b = new NumericUpDown[GRAPH_CH_NUM] { num_ch1_b, num_ch2_b };
            my_num_calibration_kitai = new NumericUpDown[GRAPH_CH_NUM] { num_ch1_kitai_val, num_ch2_kitai_val };   // 期待値
            my_txtbx_calibration_input = new TextBox[GRAPH_CH_NUM] { txtbx_ch1_input_data, txtbx_ch2_input_data };
            my_txtbx_calibration_cal = new TextBox[GRAPH_CH_NUM] { txtbx_ch1_hosei_val, txtbx_ch2_hosei_val };         // 校正後の計算値

            for (int fi = 0; fi < 64; fi++)
            {
                cmbbx_port.Items.Add(string.Format("COM{0}", fi + 1));
            }
            cmbbx_port.SelectedIndex = 0;
            for (int fi = 0; fi < baud_rate_select_datas.Length; fi++)
            {
                cmbbx_baudrate.Items.Add(baud_rate_select_datas[fi].ToString());
            }
            cmbbx_baudrate.SelectedIndex = baud_rate_default_select_idx;
            // 時間軸設定
            for (int fi = 0; fi < GRAPH_TIME_DIV_ITEM.Length; fi++)
            {
                cmbbx_ch1_time.Items.Add(GRAPH_TIME_DIV_ITEM[fi]);
                cmbbx_ch2_time.Items.Add(GRAPH_TIME_DIV_ITEM[fi]);
            }
            cmbbx_ch1_time.SelectedIndex = GRAPH_TIME_DIV_ITEM_DEFAULT;
            cmbbx_ch2_time.SelectedIndex = GRAPH_TIME_DIV_ITEM_DEFAULT;
            // トリガーレベルデフォルト値設定
            num_ch1_trigger_level.Minimum = (decimal)TRIGGER_LEVEL_MIN_VAL;
            num_ch1_trigger_level.Maximum = (decimal)TRIGGER_LEVEL_MAX_VAL;
            num_ch1_trigger_level.Value = (decimal)TRIGGER_LEVEL_DEFAULT_VAL;
            num_ch2_trigger_level.Minimum = (decimal)TRIGGER_LEVEL_MIN_VAL;
            num_ch2_trigger_level.Maximum = (decimal)TRIGGER_LEVEL_MAX_VAL;
            num_ch2_trigger_level.Value = (decimal)TRIGGER_LEVEL_DEFAULT_VAL;
            // トリガーエッジ設定
            for (int fi = 0; fi < TRIGGER_EDGE_ITEM.Length; fi++)
            {
                cmbbx_ch1_trigger_edge.Items.Add(TRIGGER_EDGE_ITEM[fi]);
                cmbbx_ch2_trigger_edge.Items.Add(TRIGGER_EDGE_ITEM[fi]);
            }
            cmbbx_ch1_trigger_edge.SelectedIndex = 0;
            cmbbx_ch2_trigger_edge.SelectedIndex = 0;

            // 初期設定ファイル読み込み
            string file_path = Path.Combine(System.Environment.CurrentDirectory, Constants.INIT_FILE_NAME);
            int func_ret = my_Init_File_Read(file_path);
            if (func_ret == 0)
            {
            }
            else
            {
                mySettingVal.Init(GRAPH_CH_NUM);
            }
            // 設定値表示
            my_setting_val_display_set();

            // チャート設定
            // 1.Seriesの追加
            chart1.Series.Clear();
            chart1.Series.Add("level");
            chart1.Series[0].Color = Color.Orange;
            chart1.Series[0].IsVisibleInLegend = false;
            chart1.Series[0].IsValueShownAsLabel = false;
            // 2.グラフのタイプの設定
            chart1.Series["level"].ChartType = System.Windows.Forms.DataVisualization.Charting.SeriesChartType.Line;
            //軸ラベルの設定
            chart1.ChartAreas[0].AxisX.Title = GRAPH_TIME_TITLE_ITEM[graph_x_select_index[0]];
            chart1.ChartAreas[0].AxisY.Title = "電圧 [V]";

            //X軸最小値、最大値、目盛間隔の設定
            chart1.ChartAreas[0].AxisX.Minimum = GRAPH_X_MIN_VALUE[graph_x_select_index[0]];
            chart1.ChartAreas[0].AxisX.Maximum = GRAPH_X_MAX_VALUE[graph_x_select_index[0]];
            chart1.ChartAreas[0].AxisX.Interval = GRAPH_X_INTERVAL_VALUE[graph_x_select_index[0]];
            chart1.ChartAreas[0].AxisX.LabelAutoFitMaxFontSize = 10;
            chart1.ChartAreas[0].AxisX.LabelStyle.ForeColor = Color.Black;
            chart1.ChartAreas[0].AxisX.MajorGrid.Enabled = true;
            chart1.ChartAreas[0].AxisX.MajorGrid.LineColor = Color.DarkGray;
            chart1.ChartAreas[0].AxisX.MinorGrid.Enabled = true;
            chart1.ChartAreas[0].AxisX.MinorGrid.LineColor = Color.LightGray;
            //chart1.ChartAreas[0].AxisX.Interval = 1000000;
            //Y軸最小値、最大値、目盛間隔の設定
            chart1.ChartAreas[0].AxisY.LabelStyle.Enabled = true;
            chart1.ChartAreas[0].AxisY.Minimum = GRAPH_VOLTAGE_SET_VAL_MIN;
            chart1.ChartAreas[0].AxisY.Maximum = GRAPH_VOLTAGE_SET_VAL_MAX;
            chart1.ChartAreas[0].AxisY.Interval = GRAPH_VOLTAGE_SET_INTERVAL;
            chart1.ChartAreas[0].AxisY.LabelAutoFitMaxFontSize = 10;
            chart1.ChartAreas[0].AxisY.LabelStyle.ForeColor = Color.Black;
            chart1.ChartAreas[0].AxisY.MajorGrid.Enabled = true;
            chart1.ChartAreas[0].AxisY.MajorGrid.LineColor = Color.DarkGray;
            chart1.ChartAreas[0].AxisY.MinorGrid.Enabled = true;
            chart1.ChartAreas[0].AxisY.MinorGrid.LineColor = Color.LightGray;
            // ダミーデータ
            chart1.Series[0].Points.AddXY(10, 0);
            // Trigger Level
            chart1.Series.Add("TriggerLevel");
            chart1.Series[1].ChartType = System.Windows.Forms.DataVisualization.Charting.SeriesChartType.Line;
            chart1.Series[1].Color = Color.Red;
            chart1.Series[1].IsVisibleInLegend = false;
            chart1.Series[1].IsValueShownAsLabel = false;

            // チャート設定
            // 1.Seriesの追加
            chart2.Series.Clear();
            chart2.Series.Add("level");
            chart2.Series[0].Color = Color.Orange;
            chart2.Series[0].IsVisibleInLegend = false;
            chart2.Series[0].IsValueShownAsLabel = false;
            // 2.グラフのタイプの設定
            chart2.Series["level"].ChartType = System.Windows.Forms.DataVisualization.Charting.SeriesChartType.Line;
            //軸ラベルの設定
            chart2.ChartAreas[0].AxisX.Title = GRAPH_TIME_TITLE_ITEM[graph_x_select_index[1]];
            chart2.ChartAreas[0].AxisY.Title = "電圧 [V]";

            //X軸最小値、最大値、目盛間隔の設定
            chart2.ChartAreas[0].AxisX.Minimum = GRAPH_X_MIN_VALUE[graph_x_select_index[1]];
            chart2.ChartAreas[0].AxisX.Maximum = GRAPH_X_MAX_VALUE[graph_x_select_index[1]];
            chart2.ChartAreas[0].AxisX.Interval = GRAPH_X_INTERVAL_VALUE[graph_x_select_index[1]];
            chart2.ChartAreas[0].AxisX.LabelAutoFitMaxFontSize = 10;
            chart2.ChartAreas[0].AxisX.LabelStyle.ForeColor = Color.Black;
            chart2.ChartAreas[0].AxisX.MajorGrid.Enabled = true;
            chart2.ChartAreas[0].AxisX.MajorGrid.LineColor = Color.DarkGray;
            chart2.ChartAreas[0].AxisX.MinorGrid.Enabled = true;
            chart2.ChartAreas[0].AxisX.MinorGrid.LineColor = Color.LightGray;
            //chart2.ChartAreas[0].AxisX.Interval = 1000000;
            //Y軸最小値、最大値、目盛間隔の設定
            chart2.ChartAreas[0].AxisY.LabelStyle.Enabled = true;
            chart2.ChartAreas[0].AxisY.Minimum = GRAPH_VOLTAGE_SET_VAL_MIN;
            chart2.ChartAreas[0].AxisY.Maximum = GRAPH_VOLTAGE_SET_VAL_MAX;
            chart2.ChartAreas[0].AxisY.Interval = GRAPH_VOLTAGE_SET_INTERVAL;
            chart2.ChartAreas[0].AxisY.LabelAutoFitMaxFontSize = 10;
            chart2.ChartAreas[0].AxisY.LabelStyle.ForeColor = Color.Black;
            chart2.ChartAreas[0].AxisY.MajorGrid.Enabled = true;
            chart2.ChartAreas[0].AxisY.MajorGrid.LineColor = Color.DarkGray;
            chart2.ChartAreas[0].AxisY.MinorGrid.Enabled = true;
            chart2.ChartAreas[0].AxisY.MinorGrid.LineColor = Color.LightGray;
            // ダミーデータ
            chart2.Series[0].Points.AddXY(10, 0);
            // Trigger Level
            chart2.Series.Add("TriggerLevel");
            chart2.Series[1].ChartType = System.Windows.Forms.DataVisualization.Charting.SeriesChartType.Line;
            chart2.Series[1].Color = Color.Red;
            chart2.Series[1].IsVisibleInLegend = false;
            chart2.Series[1].IsValueShownAsLabel = false;


            my_measure_val_display();
            my_graph_trigger_level_update(0);
            my_graph_trigger_level_update(1);

            FormUpdateTimer.Enabled = true;
        }

        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        {
            try
            {
                if (serialPort1.IsOpen == true)
                {
                    serialPort1.Close();
                }
                my_logfile_output_stop();

                // 初期設定ファイル書き込み
                string file_path = Path.Combine(System.Environment.CurrentDirectory, Constants.INIT_FILE_NAME);
                my_Init_File_Save(file_path, false);

            }
            catch
            {
            }
        }

        private void FormUpdateTimer_Tick(object sender, EventArgs e)
        {
            try
            {
                byte[] tmp_serial_data = new byte[Constants.MEASURE_DATA_BUFF_SIZE + Constants.MEASURE_RCV_DATA_HEADER_SIZE + Constants.MEASURE_RCV_DATA_FOOTER_SIZE];
                int tmp_read_idx = serial_rcv_data_read_idx;
                bool tmp_full = serial_rcv_data_full;
                int rcv_data_count = 0;
                string serial_debug_str = "";
                while (serial_rcv_data_read_idx != serial_rcv_data_write_idx || serial_rcv_data_full == true)
                {
                    if (serial_received_buff[tmp_read_idx] == Constants.MEASUREMENT_HEADER1)
                    {   // 先頭S
                        rcv_data_count = 0;
                        tmp_serial_data[rcv_data_count++] = serial_received_buff[tmp_read_idx++];
                        tmp_read_idx &= (SERIAL_RECEIVED_BUFF_SIZE - 1);
                        tmp_full = false;

                        while (tmp_read_idx != serial_rcv_data_write_idx || tmp_full == true)
                        {
                            tmp_serial_data[rcv_data_count++] = serial_received_buff[tmp_read_idx++];
                            tmp_read_idx &= (SERIAL_RECEIVED_BUFF_SIZE - 1);
                            tmp_full = false;

                            if (rcv_data_count >= tmp_serial_data.Length)
                            {
                                break;
                            }
                        }

                        if (rcv_data_count >= tmp_serial_data.Length)
                        {   // データ数OK
                            //データチェック S,M,...,E
                            if (tmp_serial_data[0] == Constants.MEASUREMENT_HEADER1 && tmp_serial_data[1] == Constants.MEASUREMENT_HEADER2 && tmp_serial_data[tmp_serial_data.Length - 1] == Constants.MEASUREMENT_FOOTER1)
                            {

                                for (int fi = 0; fi < Constants.MEASURE_DATA_NUM; fi++)
                                {
                                    Measure_Data_Buff[set_ch_val, fi] = ((tmp_serial_data[(fi * 2) + 2] & 0x7F) + ((tmp_serial_data[(fi * 2) + 3] & 0x1F) * 128));
                                    //Measure_Data_Buff[set_ch_val, fi] = ((tmp_serial_data[(fi * 2) + 2] & 0x7F) + ((tmp_serial_data[(fi * 2) + 3] & 0x1F) * 128)) - 2048;
                                    Measure_Graph_Data_Buff[set_ch_val, fi] = (Measure_Data_Buff[set_ch_val, fi] * mySettingVal.calibration_a[set_ch_val] / GRAPH_X_DATA_MAX) + mySettingVal.calibration_b[set_ch_val];
                                }

                                // 現在値セット
                                my_txtbx_calibration_input[set_ch_val].Text = string.Format("{0}", Measure_Data_Buff[set_ch_val, 0]);
                                my_set_calibration_val(set_ch_val);

                                graph_update_flag = true;


                                // ログ出力中？
                                if (logfile_out_flag == true && sw_serial_log[set_ch_val] != null)
                                {
                                    string str_log_out = "";

                                    for (int fi = 0; fi < Constants.MEASURE_DATA_NUM; fi++)
                                    {
                                        log_output_data_counter[set_ch_val]++;
                                        str_log_out = "\"" + log_output_data_counter[set_ch_val].ToString() + "\",\"" + string.Format("{0:0.000}", Measure_Graph_Data_Buff[set_ch_val, fi]) + "\"";
                                        sw_serial_log[set_ch_val].WriteLine(str_log_out);
                                    }
                                }

                                // CH更新
                                if (chkbx_ch2_enabled.Checked == true)
                                {
                                    set_ch_val++;
                                    if (set_ch_val >= GRAPH_CH_NUM)
                                    {
                                        set_ch_val = 0;
                                    }
                                }
                                serial_debug_str += "\n";
                                if (chkbx_serial_RX_Ascii.Checked == true)
                                {
                                    serial_debug_str += Encoding.ASCII.GetString(tmp_serial_data, 0, rcv_data_count);
                                }
                                else
                                {
                                    for (int fi = 0; fi < rcv_data_count; fi++)
                                    {
                                        serial_debug_str += string.Format(" {0:X2}", tmp_serial_data[fi]);
                                    }
                                }

                                // 次のデータへ
                                serial_rcv_data_read_idx = tmp_read_idx;
                                serial_rcv_data_full = false;

                                if (measure_start_flag == true)
                                {
                                    my_measurement_request_command_send(set_time_val[set_ch_val], set_ch_val, set_trigger_level[set_ch_val], set_trigger_edge[set_ch_val]);
                                }
                            }
                            else
                            {   // データ不正 次のデータへ
                                if (chkbx_serial_RX_Ascii.Checked == true)
                                {
                                    serial_debug_str += Encoding.ASCII.GetString(serial_received_buff, serial_rcv_data_read_idx, 1);
                                }
                                else
                                {
                                    serial_debug_str += string.Format(" {0:X2}", serial_received_buff[serial_rcv_data_read_idx]);
                                }

                                serial_rcv_data_read_idx++;
                                serial_rcv_data_read_idx &= (SERIAL_RECEIVED_BUFF_SIZE - 1);
                                serial_rcv_data_full = false;
                            }
                        }
                        else
                        {   // データ数が足りない
                            break;
                        }
                    }
                    else
                    {   // 先頭Dでない 次のデータへ
                        if (chkbx_serial_RX_Ascii.Checked == true)
                        {
                            serial_debug_str += Encoding.ASCII.GetString(serial_received_buff, serial_rcv_data_read_idx, 1);
                        }
                        else
                        {
                            serial_debug_str += string.Format(" {0:X2}", serial_received_buff[serial_rcv_data_read_idx]);
                        }

                        serial_rcv_data_read_idx++;
                        serial_rcv_data_read_idx &= (SERIAL_RECEIVED_BUFF_SIZE - 1);
                        serial_rcv_data_full = false;
                    }
                }
                if (serial_debug_str != "")
                {
                    rtxtbx_serial_RX.Focus();
                    rtxtbx_serial_RX.AppendText(serial_debug_str);
                }

                //// ログ出力中？
                //if (logfile_out_flag == true && sw_serial_log != null)
                //{
                //    if (log_output_data_counter < (int)num_log_out_max.Value)
                //    {
                //        if (dt_now >= dt_log_next_output)
                //        {

                //            string str_log_out = "";
                //            log_output_data_counter++;
                //            str_log_out = my_get_log_output_data();
                //            if (str_log_out != "")
                //            {
                //                sw_serial_log.WriteLine(str_log_out);
                //            }
                //            else
                //            {
                //                log_output_data_counter--;
                //            }

                //            double tmp_update_sec = (double)(num_log_output_cycle.Value);
                //            dt_log_next_output = dt_log_next_output.AddSeconds(tmp_update_sec);
                //        }
                //    }
                //    else
                //    {
                //        dt_log_next_output = DateTime.Now;
                //    }
                //}
            }
            catch
            {
            }
        }

        private void serialPort1_DataReceived(object sender, System.IO.Ports.SerialDataReceivedEventArgs e)
        {
            try
            {
                if (serialPort1.BytesToRead > 0)
                {
                    byte[] tmp_read_buff = new byte[serialPort1.BytesToRead];
                    serialPort1.Read(tmp_read_buff, 0, serialPort1.BytesToRead);

                    for (int fi = 0; fi < tmp_read_buff.Length; fi++)
                    {
                        if (serial_rcv_data_full == false)
                        {
                            serial_received_buff[serial_rcv_data_write_idx++] = tmp_read_buff[fi];

                            serial_rcv_data_write_idx &= (SERIAL_RECEIVED_BUFF_SIZE - 1);
                            if (serial_rcv_data_read_idx == serial_rcv_data_write_idx)
                            {
                                serial_rcv_data_full = true;
                            }
                        }
                    }
                }
            }
            catch
            {
            }
        }

        private void my_get_measurement_request_command_parameter()
        {
            try
            {
                for (int fi = 0; fi < GRAPH_CH_NUM; fi++)
                {
                    set_time_val[fi] = (byte)(my_cmbbx_time[fi].SelectedIndex & 0xFF);
                    double tmp_dbl = (double)my_num_trigger_level[fi].Value;
                    tmp_dbl = ((tmp_dbl - mySettingVal.calibration_b[fi]) * GRAPH_X_DATA_MAX) / mySettingVal.calibration_a[fi];
                    set_trigger_level[fi] = (int)(tmp_dbl);
                    set_trigger_edge[fi] = (byte)(my_cmbbx_trigger_edge[fi].SelectedIndex & 0xFF);
                }
            }
            catch
            {
            }
        }
        private void my_measurement_request_command_send(byte p_time, byte p_ch, int p_tigger_level, byte p_trigger_edge)
        {
            byte[] send_data = new byte[64];
            try
            {
                if (serialPort1.IsOpen == true)
                {
                    try
                    {
                        // パラメータチェック
                        if (0 <= p_time && p_time < GRAPH_TIME_DIV_ITEM_NUM
                            && 0 <= p_ch && p_ch < GRAPH_CH_NUM
                            && 0 <= p_tigger_level && p_tigger_level <= GRAPH_X_DATA_MAX
                            && 0 <= p_trigger_edge && p_trigger_edge < TRIGGER_EDGE_ITEM_NUM)
                        {
                            // SThcttttrE
                            send_data[0] = 0x53;//S
                            send_data[1] = 0x54;//T
                            send_data[2] = (byte)((0x30 + p_time) & 0xFF);//h
                            send_data[3] = (byte)((0x30 + p_ch + 1) & 0xFF);//c
                            send_data[4] = (byte)((0x30 + ((p_tigger_level % 10000) / 1000)) & 0xFF);//t
                            send_data[5] = (byte)((0x30 + ((p_tigger_level % 1000) / 100)) & 0xFF);//t
                            send_data[6] = (byte)((0x30 + ((p_tigger_level % 100) / 10)) & 0xFF);//t
                            send_data[7] = (byte)((0x30 + ((p_tigger_level % 10) / 1)) & 0xFF);//t
                            send_data[8] = (byte)((0x30 + p_trigger_edge) & 0xFF);//r
                            send_data[9] = 0x45;//E

                            serialPort1.Write(send_data, 0, 10);
                        }
                    }
                    catch
                    {
                    }
                }
            }
            catch
            {
            }
        }

        private void backgroundWorker1_DoWork(object sender, DoWorkEventArgs e)
        {
            try
            {
            }
            catch
            {
            }
        }


        private void btn_correction_save_Click(object sender, EventArgs e)
        {
            CorrectionVal myCorrectionValtmp = new CorrectionVal();
            try
            {
                saveFileDialog1.Title = "Save As...";
                saveFileDialog1.Filter = "XML file(*.xml)|*.xml|All file(*.*)|*.*";
                if(saveFileDialog1.ShowDialog() == DialogResult.OK)
                {
                    int ch_no = int.Parse(((Button)sender).Tag.ToString());
                    my_Correction_File_Save(saveFileDialog1.FileName, false, ch_no);
                }
            }
            catch
            {
            }
        }

        private void btn_correction_read_Click(object sender, EventArgs e)
        {
            CorrectionVal myCorrectionValtmp = new CorrectionVal();
            try
            {
                openFileDialog1.Title = "Open...";
                openFileDialog1.Filter = "XML file(*.xml)|*.xml|All file(*.*)|*.*";
                if (openFileDialog1.ShowDialog() == DialogResult.OK)
                {
                    int ch_no = int.Parse(((Button)sender).Tag.ToString());
                    my_Correction_File_Read(openFileDialog1.FileName, ch_no);
                    // 設定値表示
                    my_setting_val_display_set();
                }
            }
            catch
            {
            }
        }

        private int my_Correction_File_Save(string file_name, bool save_flag, int p_ch_no)
        {
            int ret = -1;
            try
            {
                System.Xml.Serialization.XmlSerializer serializer = null;
                System.IO.FileStream fs = null;

                try
                {
                    if (0 <= p_ch_no && p_ch_no < GRAPH_CH_NUM)
                    {
                        CorrectionVal myCorrectionValtmp = new CorrectionVal();

                        myCorrectionValtmp.calibration_a = mySettingVal.calibration_a[p_ch_no];
                        myCorrectionValtmp.calibration_b = mySettingVal.calibration_b[p_ch_no];

                        serializer = new System.Xml.Serialization.XmlSerializer(typeof(CorrectionVal));
                        fs = new System.IO.FileStream(file_name, System.IO.FileMode.Create);
                        serializer.Serialize(fs, myCorrectionValtmp);

                        ret = 0;
                    }
                    else
                    {
                        ret = -2;
                    }
                }
                catch
                {
                }
                finally
                {
                    if (fs != null)
                    {
                        fs.Close();
                        fs.Dispose();
                    }
                }
            }
            catch
            {
            }
            return ret;
        }

        private int my_Correction_File_Read(string file_name, int p_ch_no)
        {
            int ret = -1;
            try
            {
                // ファイル有無チェック
                if (File.Exists(file_name) == true)
                {
                    System.Xml.Serialization.XmlSerializer serializer = null;
                    System.IO.FileStream fs = null;
                    try
                    {
                        if (0 <= p_ch_no && p_ch_no < GRAPH_CH_NUM)
                        {
                            serializer = new System.Xml.Serialization.XmlSerializer(typeof(CorrectionVal));
                            fs = new System.IO.FileStream(file_name, System.IO.FileMode.Open);
                            CorrectionVal myCorrectionValtmp = (CorrectionVal)serializer.Deserialize(fs);

                            //読み込み正常
                            mySettingVal.calibration_a[p_ch_no] = myCorrectionValtmp.calibration_a;
                            mySettingVal.calibration_b[p_ch_no] = myCorrectionValtmp.calibration_b;

                            ret = 0;
                        }
                        else
                        {
                            ret = -2;
                        }
                    }
                    catch
                    {
                    }
                    finally
                    {
                        if (fs != null)
                        {
                            fs.Close();
                            fs.Dispose();
                        }
                    }
                }
            }
            catch
            {
            }
            return ret;
        }


        private int my_Init_File_Save(string file_name, bool save_flag)
        {
            int ret = -1;
            try
            {
                System.Xml.Serialization.XmlSerializer serializer = null;
                System.IO.FileStream fs = null;

                try
                {
                    serializer = new System.Xml.Serialization.XmlSerializer(typeof(SettingVal));
                    fs = new System.IO.FileStream(file_name, System.IO.FileMode.Create);
                    serializer.Serialize(fs, mySettingVal);


                    ret = 0;
                }
                catch
                {
                }
                finally
                {
                    if (fs != null)
                    {
                        fs.Close();
                        fs.Dispose();
                    }
                }
            }
            catch
            {
            }
            return ret;
        }

        private int my_Init_File_Read(string file_name)
        {
            int ret = -1;
            try
            {
                // ファイル有無チェック
                if (File.Exists(file_name) == true)
                {
                    System.Xml.Serialization.XmlSerializer serializer = null;
                    System.IO.FileStream fs = null;
                    try
                    {
                        serializer = new System.Xml.Serialization.XmlSerializer(typeof(SettingVal));
                        fs = new System.IO.FileStream(file_name, System.IO.FileMode.Open);
                        SettingVal mySettingValtmp = (SettingVal)serializer.Deserialize(fs);

                        //読み込み正常
                        mySettingVal = mySettingValtmp;

                        ret = 0;
                    }
                    catch
                    {
                    }
                    finally
                    {
                        if (fs != null)
                        {
                            fs.Close();
                            fs.Dispose();
                        }
                    }
                }
            }
            catch
            {
            }
            return ret;
        }

        private void my_setting_val_display_set()
        {
            try
            {
                setting_val_input_disabled = true;

                // 補正値
                for (int fi = 0; fi < GRAPH_CH_NUM; fi++)
                {
                    my_num_calibration_a[fi].Value = (decimal)mySettingVal.calibration_a[fi];
                    my_num_calibration_b[fi].Value = (decimal)mySettingVal.calibration_b[fi];

                    my_set_calibration_val(fi);
                }
                setting_val_input_disabled = false;
            }
            catch
            {
            }
        }
        private void my_setting_val_display_get()
        {
            try
            {
                if (setting_val_input_disabled == false)
                {   // 画面に設定値設定中以外
                    //// 設定値

                    //// 補正値
                }
            }
            catch
            {
            }
        }

        private void num_setting_val_ValueChanged(object sender, EventArgs e)
        {
            try
            {
                my_setting_val_display_get();
            }
            catch
            {
            }
        }

        private void my_measure_val_display()
        {
            try
            {

            }
            catch
            {
            }
        }

        private void btn_serial_open_Click(object sender, EventArgs e)
        {
            bool error_flag = false;
            byte[] send_data = new byte[64];
            try
            {
                if (serialPort1.IsOpen == false)
                {
                    serialPort1.PortName = cmbbx_port.SelectedItem.ToString();
                    if (0 <= cmbbx_baudrate.SelectedIndex && cmbbx_baudrate.SelectedIndex < baud_rate_select_datas.Length)
                    {
                        serialPort1.BaudRate = baud_rate_select_datas[cmbbx_baudrate.SelectedIndex];
                    }
                    else
                    {
                        error_flag = true;
                    }


                    if (error_flag == false)
                    {
                        try
                        {
                            serialPort1.WriteTimeout = 500;
                            serialPort1.ReadTimeout = 500;

                            serialPort1.Open();
                            if (serialPort1.IsOpen == true)
                            {
                                //backgroundWorker1.RunWorkerAsync();

                                //send_data[0] = 0x53;//S
                                //send_data[1] = 0x54;//T
                                //send_data[2] = 0x45;//E

                                try
                                {
                                    //serialPort1.Write(send_data, 0, send_data.Length);

                                    btn_serial_open.Enabled = false;
                                    btn_serial_close.Enabled = true;

                                    btn_measure_start.Enabled = true;
                                    btn_measure_stop.Enabled = false;
                                    btn_log_output_start.Enabled = true;
                                    btn_log_output_stop.Enabled = false;
                                }
                                catch
                                {
                                    serialPort1.Close();
                                    MessageBox.Show("シリアル通信エラー", "ERROR", MessageBoxButtons.OK, MessageBoxIcon.Error);
                                }
                            }
                            else
                            {
                                MessageBox.Show("シリアルポートオープンエラー", "ERROR", MessageBoxButtons.OK, MessageBoxIcon.Error);
                            }
                        }
                        catch
                        {
                            MessageBox.Show("シリアルポートオープンエラー", "ERROR", MessageBoxButtons.OK, MessageBoxIcon.Error);
                        }
                    }
                    else
                    {
                        MessageBox.Show("シリアルポート　設定値エラー", "ERROR", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    }
                }
            }
            catch
            {
            }
        }

        private void btn_serial_close_Click(object sender, EventArgs e)
        {
            if (serialPort1.IsOpen == true)
            {
                serialPort1.Close();

                btn_serial_open.Enabled = true;
                btn_serial_close.Enabled = false;
                btn_measure_start.Enabled = false;
                btn_measure_stop.Enabled = false;

                my_logfile_output_stop();
                btn_log_output_start.Enabled = false;
                btn_log_output_stop.Enabled = false;
            }
        }

        private void btn_measure_start_Click(object sender, EventArgs e)
        {
            byte[] send_data = new byte[64];
            try
            {
                if (serialPort1.IsOpen == true)
                {
                    try
                    {
                        set_ch_val = 0;
                        my_get_measurement_request_command_parameter();
                        my_measurement_request_command_send(set_time_val[set_ch_val], set_ch_val, set_trigger_level[set_ch_val], set_trigger_edge[set_ch_val]);

                        btn_measure_start.Enabled = false;
                        btn_measure_stop.Enabled = true;
                        gbx_ch1_calibration.Enabled = false;
                        gbx_ch2_calibration.Enabled = false;
                        gbx_ch1_wave_disp.Enabled = false;
                        gbx_ch2_wave_disp.Enabled = false;

                        // Graph設定
                        //graph_update_flag = true;
                        GraphUpdateTimer.Enabled = true;

                        measure_start_flag = true;
                    }
                    catch
                    {
                        btn_measure_start.Enabled = true;
                        btn_measure_stop.Enabled = false;
                        gbx_ch1_calibration.Enabled = true;
                        gbx_ch2_calibration.Enabled = true;
                        gbx_ch1_wave_disp.Enabled = true;
                        gbx_ch2_wave_disp.Enabled = true;
                    }
                }
            }
            catch
            {
            }
        }

        private void btn_measure_stop_Click(object sender, EventArgs e)
        {
            try
            {
                graph_update_flag = false;
                //GraphUpdateTimer.Enabled = false;

                measure_start_flag = false;

                btn_measure_start.Enabled = true;
                btn_measure_stop.Enabled = false;
                gbx_ch1_calibration.Enabled = true;
                gbx_ch2_calibration.Enabled = true;
                gbx_ch1_wave_disp.Enabled = true;
                gbx_ch2_wave_disp.Enabled = true;
            }
            catch
            {
            }
        }

        private void btn_log_output_start_Click(object sender, EventArgs e)
        {
            try
            {
                my_logfile_output_start();
            }
            catch
            {
            }
        }

        private void btn_log_output_stop_Click(object sender, EventArgs e)
        {
            try
            {
                btn_log_output_start.Enabled = true;
                btn_log_output_stop.Enabled = false;

                my_logfile_output_stop();
            }
            catch
            {
            }
        }

        private void my_logfile_output_start()
        {
            int fi;
            string outStr = "";
            try
            {

                try
                {
                    for (int ch_no = 0; ch_no < GRAPH_CH_NUM; ch_no++ )
                    {
                        string log_file_path = "";
                        string file_datetime = "";

                        file_datetime = string.Format("{0:0000}{1:00}{2:00}_{3:00}{4:00}{5:00}", DateTime.Now.Year, DateTime.Now.Month, DateTime.Now.Day, DateTime.Now.Hour, DateTime.Now.Minute, DateTime.Now.Second);
                        log_file_path = System.Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments) + LOG_FILE_NAME_CH[ch_no] + file_datetime + LOG_FILE_EXTEN;

                        sw_serial_log[ch_no] = new StreamWriter(log_file_path);
                        
                        outStr = "";
                        // ヘッダ
                        for (fi = 0; fi < LOG_FILE_HEADER.Length; fi++)
                        {
                            if (fi >= 1)
                            {
                                outStr += ",";
                            }
                            outStr += "\"" + LOG_FILE_HEADER[fi] + "\"";
                        }
                        sw_serial_log[ch_no].WriteLine(outStr);

                        log_output_data_counter[ch_no] = 0;
                    }

                    btn_log_output_start.Enabled = false;
                    btn_log_output_stop.Enabled = true;

                    logfile_out_flag = true;
                }
                catch
                {
                    for (int ch_no = 0; ch_no < GRAPH_CH_NUM; ch_no++)
                    {
                        if (sw_serial_log[ch_no] != null)
                        {
                            sw_serial_log[ch_no].Close();
                            sw_serial_log[ch_no].Dispose();
                            sw_serial_log[ch_no] = null;
                        }
                    }

                    btn_log_output_start.Enabled = true;
                    btn_log_output_stop.Enabled = false;
                }

            }
            catch
            {
            }
        }
        private void my_logfile_output_stop()
        {
            try
            {
                for (int ch_no = 0; ch_no < GRAPH_CH_NUM; ch_no++)
                {
                    if (sw_serial_log[ch_no] != null)
                    {
                        sw_serial_log[ch_no].Close();
                        sw_serial_log[ch_no].Dispose();
                        sw_serial_log[ch_no] = null;
                    }
                }

                logfile_out_flag = false;
            }
            catch
            {
            }
        }

        private void my_graph_update(int p_ch)
        {
            try
            {
                if(p_ch == 0)
                {   // ch1
                    chart1.Series[0].Points.Clear();

                    my_graph_Axis_Y_update(p_ch);
                    //double y_min = mySettingVal.calibration_a[p_ch] * 0 + mySettingVal.calibration_b[p_ch];
                    //double y_max = mySettingVal.calibration_a[p_ch] * 1 + mySettingVal.calibration_b[p_ch];
                    //double y_int = (y_max - y_min) / 6;
                    //y_int += 0.1;
                    //y_int = y_int - (y_int % 0.1);
                    //chart1.ChartAreas[0].AxisY.Minimum = y_min;
                    //chart1.ChartAreas[0].AxisY.Maximum = y_max;
                    //chart1.ChartAreas[0].AxisY.Interval = y_int;

                    int set_data_num = (int)GRAPH_X_DISP_DATA_NUM[graph_x_select_index[p_ch]];
                    double x_interval = GRAPH_X_MAX_VALUE[graph_x_select_index[p_ch]] / GRAPH_X_DISP_DATA_NUM[graph_x_select_index[p_ch]];
                    double set_x_val = 0;
                    for (int fi = 0; fi < set_data_num; fi++)
                    {
                        chart1.Series[0].Points.Add(new DataPoint(set_x_val, Measure_Graph_Data_Buff[p_ch, fi]));
                        set_x_val += x_interval;
                    }
                }
                else if(p_ch == 1)
                {   // ch2
                    chart2.Series[0].Points.Clear();

                    my_graph_Axis_Y_update(p_ch);
                    //double y_min = mySettingVal.calibration_a[p_ch] * 0 + mySettingVal.calibration_b[p_ch];
                    //double y_max = mySettingVal.calibration_a[p_ch] * 1 + mySettingVal.calibration_b[p_ch];
                    //double y_int = (y_max - y_min) / 6;
                    //y_int += 0.1;
                    //y_int = y_int - (y_int % 0.1);
                    //chart2.ChartAreas[0].AxisY.Minimum = y_min;
                    //chart2.ChartAreas[0].AxisY.Maximum = y_max;
                    //chart2.ChartAreas[0].AxisY.Interval = y_int;

                    int set_data_num = (int)GRAPH_X_DISP_DATA_NUM[graph_x_select_index[p_ch]];
                    double x_interval = GRAPH_X_MAX_VALUE[graph_x_select_index[p_ch]] / GRAPH_X_DISP_DATA_NUM[graph_x_select_index[p_ch]];
                    double set_x_val = 0;
                    for (int fi = 0; fi < set_data_num; fi++)
                    {
                        chart2.Series[0].Points.Add(new DataPoint(set_x_val, Measure_Graph_Data_Buff[p_ch, fi]));
                        set_x_val += x_interval;
                    }
                }
            }
            catch
            {
            }
        }
        private void my_graph_Axis_Y_update(int p_ch)
        {
            try
            {
                if (0 <= p_ch  && p_ch < GRAPH_CH_NUM)
                {
                    double y_min = mySettingVal.calibration_a[p_ch] * 0 + mySettingVal.calibration_b[p_ch];
                    double y_max = mySettingVal.calibration_a[p_ch] * 1 + mySettingVal.calibration_b[p_ch];
                    double y_int = (y_max - y_min) / 6;
                    y_int += 0.1;
                    y_int = y_int - (y_int % 0.1);

                    if(p_ch == 0)
                    {
                        chart1.ChartAreas[0].AxisY.Minimum = y_min;
                        chart1.ChartAreas[0].AxisY.Maximum = y_max;
                        chart1.ChartAreas[0].AxisY.Interval = y_int;
                    }
                    else if (p_ch == 1)
                    {
                        chart2.ChartAreas[0].AxisY.Minimum = y_min;
                        chart2.ChartAreas[0].AxisY.Maximum = y_max;
                        chart2.ChartAreas[0].AxisY.Interval = y_int;
                    }
                }
            }
            catch
            {
            }
        }
        private void my_graph_trigger_level_update(int p_ch)
        {
            try
            {
                double set_trigger_level = 0;
                if (p_ch == 0)
                {   // ch1
                    my_set_calibration_val(p_ch);
                    set_trigger_level = (double)(my_num_trigger_level[p_ch].Value);

                    // Trigger Level
                    chart1.Series[1].Points.Clear();
                    chart1.Series[1].Points.AddXY(chart1.ChartAreas[0].AxisX.Minimum, set_trigger_level);
                    chart1.Series[1].Points.AddXY(chart1.ChartAreas[0].AxisX.Maximum, set_trigger_level);
                }
                else if (p_ch == 1)
                {   // ch2
                    my_set_calibration_val(p_ch);
                    set_trigger_level = (double)(my_num_trigger_level[p_ch].Value);

                    // Trigger Level
                    chart2.Series[1].Points.Clear();
                    chart2.Series[1].Points.AddXY(chart2.ChartAreas[0].AxisX.Minimum, set_trigger_level);
                    chart2.Series[1].Points.AddXY(chart2.ChartAreas[0].AxisX.Maximum, set_trigger_level);
                }
            }
            catch
            {
            }
        }
        private void my_graph_Axis_X_update(int p_ch, int p_x_idx)
        {
            try
            {
                if (0 <= p_x_idx && p_x_idx < GRAPH_TIME_DIV_ITEM_NUM)
                {
                    if (p_ch == 0)
                    {   // ch1
                        graph_x_select_index[p_ch] = p_x_idx;

                        chart1.ChartAreas[0].AxisX.Title = GRAPH_TIME_TITLE_ITEM[graph_x_select_index[p_ch]];
                        chart1.ChartAreas[0].AxisX.Minimum = GRAPH_X_MIN_VALUE[graph_x_select_index[p_ch]];
                        chart1.ChartAreas[0].AxisX.Maximum = GRAPH_X_MAX_VALUE[graph_x_select_index[p_ch]];
                        chart1.ChartAreas[0].AxisX.Interval = GRAPH_X_INTERVAL_VALUE[graph_x_select_index[p_ch]];
                    }
                    else if (p_ch == 1)
                    {   // ch2
                        graph_x_select_index[p_ch] = p_x_idx;

                        chart2.ChartAreas[0].AxisX.Title = GRAPH_TIME_TITLE_ITEM[graph_x_select_index[p_ch]];
                        chart2.ChartAreas[0].AxisX.Minimum = GRAPH_X_MIN_VALUE[graph_x_select_index[p_ch]];
                        chart2.ChartAreas[0].AxisX.Maximum = GRAPH_X_MAX_VALUE[graph_x_select_index[p_ch]];
                        chart2.ChartAreas[0].AxisX.Interval = GRAPH_X_INTERVAL_VALUE[graph_x_select_index[p_ch]];
                    }
                }
            }
            catch
            {
            }
        }

        private void GraphUpdateTimer_Tick(object sender, EventArgs e)
        {
            try
            {
                if (graph_update_flag == true)
                {   // グラフ更新中

                    // データ表示
                    my_graph_trigger_level_update(0);
                    my_graph_update(0);
                    if(chkbx_ch2_enabled.Checked == true)
                    {
                        my_graph_trigger_level_update(1);
                        my_graph_update(1);
                    }
                }
                else
                {   //　グラフ更新停止
                }
            }
            catch
            {
            }
        }

        private string my_get_log_output_data()
        {
            string ret_val = "";
            //double tmp_dbl = 0;
            try
            {
                //// no
                //ret_val = "\"" + log_output_data_counter.ToString() + "\"";
                //// time stamp
                //ret_val += ",\"" + dt_log_next_output.ToString("yyyy/MM/dd") + "\"";
                //ret_val += ",\"" + dt_log_next_output.ToString("HH:mm:ss.fff") + "\"";
                ////ret_val += ",\"" + dt_MeasureVal_next_update.ToString("yyyy/MM/dd HH:mm:ss.ffff") + "\"";

                //// 電圧
                //ret_val += ",\"" + string.Format("{0:0.000}", myMeasureVal.voltage) +"\"";
                //// 電流
                //ret_val += ",\"" + string.Format("{0:0.0000}", myMeasureVal.current) + "\"";
                //// 電力
                //ret_val += ",\"" + string.Format("{0:0.000}", myMeasureVal.voltage * myMeasureVal.current) + "\"";
                //// 高抵抗
                //tmp_dbl = myMeasureVal.resistance_h;
                //if (tmp_dbl >= Constants.MEASUREMENT_RESISTANCE_H_RANGE_OVER_VAL)
                //{
                //    tmp_dbl = Constants.MEASUREMENT_RESISTANCE_H_RANGE_OVER_VAL;
                //}
                //ret_val += ",\"" + string.Format("{0:0.0}", tmp_dbl) + "\"";
                //// 低抵抗
                //tmp_dbl = myMeasureVal.resistance_l;
                //if (tmp_dbl >= Constants.MEASUREMENT_RESISTANCE_L_RANGE_OVER_VAL)
                //{
                //    tmp_dbl = Constants.MEASUREMENT_RESISTANCE_L_RANGE_OVER_VAL;
                //}
                //ret_val += ",\"" + string.Format("{0}", tmp_dbl) + "\"";
                //// 容量
                //tmp_dbl = myMeasureVal.capacitance;
                //if (tmp_dbl < 0)
                //{   // 負になったら０に制限
                //    tmp_dbl = 0;
                //}
                //ret_val += ",\"" + string.Format("{0}", tmp_dbl) + "\"";
                //// 周波数
                //ret_val += ",\"" + string.Format("{0}", myMeasureVal.frequency) + "\"";
            }
            catch
            {
            }
            return ret_val;
        }

        private void btn_serial_rcv_log_clear_Click(object sender, EventArgs e)
        {
            try
            {
                rtxtbx_serial_RX.Text = "";
            }
            catch
            {
            }
        }

        private void num_trigger_level_ValueChanged(object sender, EventArgs e)
        {
            try
            {
                int ch_no = int.Parse(((NumericUpDown)sender).Tag.ToString());
                my_graph_trigger_level_update(ch_no);
            }
            catch
            {
            }
        }

        private void chkbx_ch2_enabled_CheckedChanged(object sender, EventArgs e)
        {
            try
            {
                gbx_ch2.Enabled = chkbx_ch2_enabled.Checked;
            }
            catch
            {
            }
        }

        private void cmbbx_time_SelectedIndexChanged(object sender, EventArgs e)
        {
            try
            {
                int ch_no = int.Parse(((ComboBox)sender).Tag.ToString());
                int cmbbx_idx = ((ComboBox)sender).SelectedIndex;
                my_graph_Axis_X_update(ch_no, cmbbx_idx);
                my_graph_trigger_level_update(ch_no);
            }
            catch
            {
            }
        }

        private void my_set_calibration_val(int p_ch_no)
        {
            try
            {
                double val_a = 0;
                double val_b = 0;
                double input_val = 0;
                double tmp_dbl = 0;

                if(0 <= p_ch_no && p_ch_no < GRAPH_CH_NUM)
                {
                    val_a = (double)my_num_calibration_a[p_ch_no].Value;
                    val_b = (double)my_num_calibration_b[p_ch_no].Value;
                    input_val = double.Parse(my_txtbx_calibration_input[p_ch_no].Text);

                    tmp_dbl = (input_val * val_a / GRAPH_X_DATA_MAX) + val_b;
                    my_txtbx_calibration_cal[p_ch_no].Text = string.Format("{0:0.000}", tmp_dbl);

                    mySettingVal.calibration_a[p_ch_no] = val_a;
                    mySettingVal.calibration_b[p_ch_no] = val_b;

                    // Trigger Level 設定範囲設定
                    double tmp_now_trigger_level = (double)my_num_trigger_level[p_ch_no].Value;
                    double x_min = mySettingVal.calibration_a[p_ch_no] * 0 + mySettingVal.calibration_b[p_ch_no];
                    double x_max = mySettingVal.calibration_a[p_ch_no] * 1 + mySettingVal.calibration_b[p_ch_no];
                    if(tmp_now_trigger_level < x_min)
                    {
                        tmp_now_trigger_level = x_min;
                    }
                    if (x_max < tmp_now_trigger_level)
                    {
                        tmp_now_trigger_level = x_max;
                    }
                    my_num_trigger_level[p_ch_no].Minimum = (decimal)x_min;
                    my_num_trigger_level[p_ch_no].Maximum = (decimal)x_max;
                    my_num_trigger_level[p_ch_no].Value = (decimal)tmp_now_trigger_level;

                    my_graph_Axis_Y_update(p_ch_no);
                }
            }
            catch
            {
            }
        }

        private void btn_gain_Click(object sender, EventArgs e)
        {
            try
            {
                double val_a = 0;
                double val_b = 0;
                double input_val = 0;
                double kitai_val = 0;
                double tmp_dbl = 0;

                int ch_no = int.Parse(((Button)sender).Tag.ToString());
                if (0 <= ch_no && ch_no < GRAPH_CH_NUM)
                {
                    val_a = (double)my_num_calibration_a[ch_no].Value;
                    val_b = (double)my_num_calibration_b[ch_no].Value;
                    kitai_val = (double)my_num_calibration_kitai[ch_no].Value;
                    input_val = double.Parse(my_txtbx_calibration_input[ch_no].Text);

                    tmp_dbl = (kitai_val - val_b) / (input_val / GRAPH_X_DATA_MAX);
                    my_num_calibration_a[ch_no].Value = (decimal)tmp_dbl;


                    my_get_measurement_request_command_parameter();
                }
            }
            catch
            {
            }
        }

        private void btn_offset_Click(object sender, EventArgs e)
        {
            try
            {
                double val_a = 0;
                double val_b = 0;
                double input_val = 0;
                double kitai_val = 0;
                double tmp_dbl = 0;

                int ch_no = int.Parse(((Button)sender).Tag.ToString());
                if (0 <= ch_no && ch_no < GRAPH_CH_NUM)
                {
                    val_a = (double)my_num_calibration_a[ch_no].Value;
                    val_b = (double)my_num_calibration_b[ch_no].Value;
                    kitai_val = (double)my_num_calibration_kitai[ch_no].Value;
                    input_val = double.Parse(my_txtbx_calibration_input[ch_no].Text);

                    tmp_dbl = kitai_val - (input_val * val_a / GRAPH_X_DATA_MAX);
                    my_num_calibration_b[ch_no].Value = (decimal)tmp_dbl;


                    my_get_measurement_request_command_parameter();
                }
            }
            catch
            {
            }
        }

        private void num_a_ValueChanged(object sender, EventArgs e)
        {
            try
            {
                if (setting_val_input_disabled == false)
                {
                    int ch_no = int.Parse(((NumericUpDown)sender).Tag.ToString());
                    my_set_calibration_val(ch_no);
                }
            }
            catch
            {
            }
        }

        private void num_b_ValueChanged(object sender, EventArgs e)
        {
            try
            {
                if (setting_val_input_disabled == false)
                {
                    int ch_no = int.Parse(((NumericUpDown)sender).Tag.ToString());
                    my_set_calibration_val(ch_no);
                }
            }
            catch
            {
            }
        }

    }
}
